define("app/army",function(require,exports,module){
"use strict";

var _scene = _interopRequireDefault(require("libs/ni/scene"));

var _db = _interopRequireDefault(require("libs/ni/db"));

var _widget = _interopRequireDefault(require("libs/ni/widget"));

var _cfgmrg = _interopRequireDefault(require("libs/ni/cfgmrg"));

var _appEmitter = require("app/appEmitter");

var _connect = _interopRequireDefault(require("libs/ni/connect"));

var _global = require("app/global");

var _music = _interopRequireDefault(require("libs/ni/music"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/****************** 导出 ******************/

/****************** 本地 ******************/
var heroNode = [];
var armyNode = [];
var hurtNode = [];

var Army =
/*#__PURE__*/
function () {
  function Army() {
    _classCallCheck(this, Army);
  }

  _createClass(Army, null, [{
    key: "initDB",
    value: function initDB() {
      //初始化英雄数据库 own：[[武将ID，带兵数量，后天成长属性,位置ID,受伤]] add[统帅加成，步兵加成，骑兵加成，弓兵加成]MaxHero:[能上阵将领数量,最大招募将领数量,已带兵将领数量]
      _db.default.init("hero", {
        MaxHero: [1, 1, 0],
        own: [],
        enemy: [],
        left: leftHero,
        choose: [1212, 1208, 1200],
        add: [0, 0, 0, 0]
      });

      _db.default.init("army", {
        cur: [0],
        total: [0],
        price: [250, 5, 1],
        max: [1000]
      }); //price:[价格,数量]

    } // static eatGold(){
    //     Connect.request({type:"app/res@eatGold",arg:{}},(data) => {
    //         if(data.err){
    //             return console.log(data.err.reson);
    //         }
    //         DB.data.res.gold[5] = data.ok;
    //     })
    // }

  }, {
    key: "updateArmy",
    value: function updateArmy() {
      if (armyNode[0] != undefined && _global.Global.mainFace.id == 3) {
        armyNode[0].text = "".concat(_db.default.data.army.cur[0], "/").concat(_db.default.data.army.max[0]);
      }
    }
  }, {
    key: "updateHero",
    value: function updateHero() {
      var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero");

      if (_global.Global.mainFace.id == 3) {
        for (var i = 0; i < _db.default.data.hero.own.length; i++) {
          var id = _db.default.data.hero.own[i][0];

          if (heroNode[i] != undefined) {
            heroNode[i].text = "".concat(bcfg[_db.default.data.hero.own[i][0]]["name"]);
            heroNode[i].style.fill = _global.Global.color[bcfg[id]["color"]];

            if (_db.default.data.hero.own[i][4] > 0) {
              hurtNode[i].text = "(\u4F24".concat(100 - _db.default.data.hero.own[i][4], "%)");
              hurtNode[i].style.fill = _global.Global.color[6];
            } else {
              hurtNode[i].text = "(".concat(_db.default.data.hero.own[i][1], "/").concat(bcfg[id]["command"] + _db.default.data.hero.add[0], ")");
              hurtNode[i].style.fill = _global.Global.color[1];
            }
          }
        }
      }
    }
  }, {
    key: "updatecost",
    value: function updatecost() {
      if (_global.Global.mainFace.id == 3) {
        var enough = 2;

        if (_db.default.data.res.gold[1] < parseInt(armyNode[2].text)) {
          enough = 6;
        }

        if (armyNode[2].style.fill != _global.Global.color[enough]) {
          armyNode[2].style.fill = _global.Global.color[enough];
        }
      }
    }
  }, {
    key: "updatePrice",
    value: function updatePrice() {
      if (_global.Global.mainFace.id == 3) {
        armyNode[2].text = "".concat(Math.ceil(_db.default.data.army.price[0] * _db.default.data.army.price[2] - 0.5), "\u9EC4\u91D1");
      }
    }
  }]);

  return Army;
}();
/**
 * @description  添人按钮组件
 */


Army.arms_Cname = ["步兵", "骑兵", "弓兵"];
Army.hero_top = [30, 160, 260, 360, 460, 560];

var WHero =
/*#__PURE__*/
function (_Widget) {
  _inherits(WHero, _Widget);

  function WHero() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, WHero);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(WHero)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.backNode = void 0;
    return _this;
  }

  _createClass(WHero, [{
    key: "setProps",
    value: function setProps(props) {
      var i = props.id,
          id = _db.default.data.hero.own[i][0],
          bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          max = bcfg[id]["command"] + _db.default.data.hero.add[0],
          name = bcfg[id]["name"];

      _get(_getPrototypeOf(WHero.prototype), "setProps", this).call(this, props); //适配


      var n = Math.floor((_scene.default.screen.width - 230 - 4 * 90 - 60) / 6);
      this.cfg.children[1].props.left = 200 + n + 45;
      this.cfg.children[2].props.left = 200 + 2 * n + 45 + 90;
      this.cfg.children[3].props.left = 200 + 3 * n + 45 + 180;
      this.cfg.children[4].props.left = 200 + 4 * n + 45 + 270;
      this.cfg.children[5].data.left = 200 + 5 * n + 360;
      this.cfg.children[0].children[0].data.text = "".concat(name);
      this.cfg.children[0].children[0].data.style.fill = _global.Global.color[bcfg[id]["color"]];
      this.cfg.data.top = Army.hero_top[i + 1] + 330;
      this.cfg.children[0].on = {
        "tap": {
          "func": "dis_hero",
          "arg": [i]
        }
      };
      this.cfg.children[1].props.on = {
        "tap": {
          "func": "army_plus",
          "arg": [_db.default.data.hero.own[i][3]]
        }
      };
      this.cfg.children[2].props.on = {
        "tap": {
          "func": "army_minus",
          "arg": [_db.default.data.hero.own[i][3]]
        }
      };
      this.cfg.children[3].props.on = {
        "tap": {
          "func": "army_max",
          "arg": [_db.default.data.hero.own[i][3]]
        }
      };
      this.cfg.children[4].props.on = {
        "tap": {
          "func": "army_zero",
          "arg": [_db.default.data.hero.own[i][3]]
        }
      };
      this.cfg.children[5].on = {
        "tap": {
          "func": "hero_delete",
          "arg": [_db.default.data.hero.own[i][3]]
        }
      };

      if (_db.default.data.hero.own[i][4] > 0) {
        this.cfg.children[0].children[1].data.text = "(\u4F24".concat(100 - _db.default.data.hero.own[i][4], "%)");
      } else {
        this.cfg.children[0].children[1].data.text = "(".concat(_db.default.data.hero.own[i][1], "/").concat(max, ")");
      }
    }
  }, {
    key: "dis_hero",
    value: function dis_hero(type) {
      _music.default.play("audio/but.mp3");

      this.backNode = _scene.default.open("app-ui-back", _scene.default.root);

      _scene.default.open("app-ui-heroDis", this.backNode, null, {
        id: type
      });
    } //加1个人

  }, {
    key: "army_plus",
    value: function army_plus(id) {
      var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero");

      _connect.default.request({
        type: "app/army@army_plus",
        arg: id
      }, function (data) {
        if (data.err) {
          if (data.err == 3) {
            _appEmitter.AppEmitter.emit("message", "\u76EE\u524D\u6700\u591A".concat(_db.default.data.hero.MaxHero[0], "\u540D\u5C06\u9886\u540C\u65F6\u5E26\u5175"));
          } else if (data.err == 4) {
            _appEmitter.AppEmitter.emit("message", "".concat(bcfg[_db.default.data.hero.own[id][0]]["name"], "\u6B63\u5728\u517B\u4F24\uFF0C\u65E0\u6CD5\u5E26\u5175\u3002"));
          }

          return console.log(data.err.reson);
        } else {
          _db.default.data.hero.own[id][1] = data.ok[0];
          _db.default.data.army.cur[0] = data.ok[1];
          _db.default.data.hero.MaxHero[2] = data.ok[2];
        }
      });
    } //减1个人

  }, {
    key: "army_minus",
    value: function army_minus(id) {
      _connect.default.request({
        type: "app/army@army_minus",
        arg: id
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.hero.own[id][1] = data.ok[0];
        _db.default.data.army.cur[0] = data.ok[1];
        _db.default.data.hero.MaxHero[2] = data.ok[2];
      });
    } //人数清0

  }, {
    key: "army_zero",
    value: function army_zero(id) {
      _connect.default.request({
        type: "app/army@army_zero",
        arg: id
      }, function (data) {
        if (data.err) {
          return console.log(data.err.reson);
        }

        _db.default.data.hero.own[id][1] = data.ok[0];
        _db.default.data.army.cur[0] = data.ok[1];
      });
    } //满编

  }, {
    key: "army_max",
    value: function army_max(id) {
      _connect.default.request({
        type: "app/army@army_max",
        arg: id
      }, function (data) {
        var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero");

        if (data.err) {
          if (data.err == 3) {
            _appEmitter.AppEmitter.emit("message", "\u76EE\u524D\u6700\u591A".concat(_db.default.data.hero.MaxHero[0], "\u540D\u5C06\u9886\u540C\u65F6\u5E26\u5175"));
          } else if (data.err == 4) {
            _appEmitter.AppEmitter.emit("message", "".concat(bcfg[_db.default.data.hero.own[id][0]]["name"], "\u6B63\u5728\u517B\u4F24\uFF0C\u65E0\u6CD5\u5E26\u5175\u3002"));
          }
        } else {
          _db.default.data.hero.own[id][1] = data.ok[0];
          _db.default.data.army.cur[0] = data.ok[1];
          _db.default.data.hero.MaxHero[2] = data.ok[2];
        }
      });
    } //革职

  }, {
    key: "hero_delete",
    value: function hero_delete(id) {
      var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          name = bcfg[_db.default.data.hero.own[id][0]]["name"];

      _music.default.play("audio/but.mp3");

      _appEmitter.AppEmitter.emit("stagePause");

      _scene.default.open("app-ui-confirm", _global.Global.mainFace.node, null, {
        text: "\u9769\u804C\u540E\uFF0C\u60A8\u5C06\u6C38\u8FDC\u5931\u53BB".concat(name, "\u3002\n\u786E\u8BA4\u5417\uFF1F"),
        on: "hero_delete",
        arg: [id]
      });
    }
  }, {
    key: "added",
    value: function added(node) {
      hurtNode[node.widget.props.id] = this.elements.get("button_hurt");
      heroNode[node.widget.props.id] = this.elements.get("button_hero");
    }
  }]);

  return WHero;
}(_widget.default);
/**
 * @description  军队界面组件
 */


var WArmy =
/*#__PURE__*/
function (_Widget2) {
  _inherits(WArmy, _Widget2);

  function WArmy() {
    _classCallCheck(this, WArmy);

    return _possibleConstructorReturn(this, _getPrototypeOf(WArmy).apply(this, arguments));
  }

  _createClass(WArmy, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WArmy.prototype), "setProps", this).call(this, props);

      var color = 6,
          cost = Math.ceil(_db.default.data.army.price[0] * _db.default.data.army.price[2] - 0.5);
      this.cfg.children[2].props.left = _scene.default.screen.width - 95;
      this.cfg.children[3].data.left = _scene.default.screen.width - 150 - (cost > 9999 ? 14 : 0);
      this.cfg.children[1].data.text = "".concat(_db.default.data.army.cur[0], "/").concat(_db.default.data.army.max[0]);
      this.cfg.children[3].data.text = "".concat(cost, "\u9EC4\u91D1");
      this.cfg.children[7].data.text = "".concat(_db.default.data.hero.own.length, "/").concat(_db.default.data.hero.MaxHero[1]); //消耗加颜色

      if (_db.default.data.res.gold[1] >= parseInt(this.cfg.children[3].data.text)) {
        color = 2;
      }

      this.cfg.children[3].data.style.fill = _global.Global.color[color];

      if (!_db.default.data.hero.own.length) {
        this.cfg.children[8].data.text = "请前往酒馆招募将领";
      }
    }
  }, {
    key: "added",
    value: function added(node) {
      armyNode[0] = this.elements.get("army_number");
      armyNode[1] = this.elements.get("hero_number");
      armyNode[2] = this.elements.get("army_price");
    }
  }, {
    key: "army_buy",
    value: function army_buy() {
      _connect.default.request({
        type: "app/army@army_buy",
        arg: []
      }, function (data) {
        if (data.err == 1) {
          _appEmitter.AppEmitter.emit("message", "黄金不足！");

          return console.log(data.err.reson);
        } else if (data.err == 2) {
          _appEmitter.AppEmitter.emit("message", "空闲士兵已达上限！");

          return console.log(data.err.reson);
        } else {
          _db.default.data.res.gold[1] = data.ok[0];
          var n = data.ok[1] - _db.default.data.army.total[0];
          _db.default.data.army.total[0] = data.ok[1];
          _db.default.data.army.cur[0] = data.ok[2];

          _appEmitter.AppEmitter.emit("message", "\u7A7A\u95F2\u58EB\u5175+".concat(n));
        }
      });
    }
  }]);

  return WArmy;
}(_widget.default); //英雄介绍弹窗


var WheroDis =
/*#__PURE__*/
function (_Widget3) {
  _inherits(WheroDis, _Widget3);

  function WheroDis() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, WheroDis);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(WheroDis)).call.apply(_getPrototypeOf3, [this].concat(args)));
    _this2.node = void 0;
    return _this2;
  }

  _createClass(WheroDis, [{
    key: "setProps",
    value: function setProps(props) {
      _get(_getPrototypeOf(WheroDis.prototype), "setProps", this).call(this, props);

      var i = props.id,
          bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
          id = _db.default.data.hero.own[i][0],
          armsId = bcfg[id]["arms"],
          max = bcfg[id]["command"] + _db.default.data.hero.add[0],
          name = bcfg[id]["name"];

      this.cfg.data.left = Math.floor(_scene.default.screen.width - this.cfg.data.width) / 2;
      this.cfg.children[1].data.text = "".concat(name, "(").concat(_db.default.data.hero.own[i][1], "/").concat(max, ")");
      this.cfg.children[2].data.text = "\u7EDF\u5E05\uFF1A".concat(bcfg[id]["command"], "\uFF08+").concat(_db.default.data.hero.add[0], "\uFF09");
      this.cfg.children[3].data.text = "".concat(Army.arms_Cname[armsId], "\uFF1A").concat(Math.floor(bcfg[id]["number"] + _db.default.data.hero.own[_db.default.data.hero.own[i][3]][2]), "\uFF08+").concat(_db.default.data.hero.add[armsId + 1], "\uFF09");
    }
  }]);

  return WheroDis;
}(_widget.default);
/**
 * @description 打开军队界面
 */


var open = function open() {
  _global.Global.mainFace.node = _scene.default.open("app-ui-army", _scene.default.root);
  _global.Global.mainFace.id = 3; //显示解锁的工作按钮

  for (var i = 0; i < _db.default.data.hero.own.length; i++) {
    _scene.default.open("app-ui-armyButton", _global.Global.mainFace.node, null, {
      id: i
    });
  }
};
/****************** 立即执行 ******************/
//注册组件


_widget.default.registW("app-ui-army", WArmy);

_widget.default.registW("app-ui-armyButton", WHero);

_widget.default.registW("app-ui-heroDis", WheroDis);

var bcfg = _cfgmrg.default.getOne("app/cfg/hero.json@hero"),
    leftHero = [[], [], [], [], [], []];

for (var i in bcfg) {
  leftHero[bcfg[i]["color"]].push(i);
} //注册军队人口监听


_db.default.emitter.add("army.cur.0", function () {
  Army.updateArmy();
  Army.updateHero();
});

_db.default.emitter.add("army.max.0", function () {
  Army.updateArmy();
}); // DB.emitter.add(`army.total.0`, () => {
//     Army.eatGold()
// });
//注册页面打开事件


_appEmitter.AppEmitter.add("intoArmy", function (node) {
  open();
}); //注册消耗黄金监听


_db.default.emitter.add("res.gold.1", function () {
  Army.updatecost();
}); //注册将领受伤监听


_db.default.emitter.add("hero.own", function () {
  Army.updateHero();
}); //注册招兵费用


_db.default.emitter.add("army.price.0", function () {
  Army.updatePrice();
}); //初始化数据库


_appEmitter.AppEmitter.add("initDB", function (node) {
  Army.initDB();
});
})